#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

from datetime import datetime
from enum import Enum


class ExtendedEnum(Enum):
    pass


class Access(ExtendedEnum):
    read = 0
    read_write = 1


class AttrType(ExtendedEnum):
    settings = 0
    diags = 1


class DataType(ExtendedEnum):
    bool = 0
    short = 1
    long = 2
    float = 3
    string = 4
    # special types that have the formula embedded
    volts = 10
    angle = 11


class Attribute:
    """
Object with the fields corresponding to the rows in the csv table
    """
    __address = None
    __name = None
    __access = None
    __attr_type = None
    __data_type = None
    __unit = None
    __min_value = None
    __max_value = None
    __fwrite = None
    __fread = None

    __last_update = None
    __value = None

    def __init__(self, address, name, access, attr_type, data_type,
                 unit=None, min_value=None, max_value=None, fwrite=None,
                 fread=None):
        """
Class to have objects that represents each of the registers in the lower level
board.

Special case in data_type of volts and angle. They don't need formulas because
they are fixed when establish this type.

        :param address: numeric field
        :param name: strign field
        :param access: read | read_write
        :param attr_type: settings | loops
        :param data_type: bool | short | long | float | string | volts | angle
        :param unit: degress | Hz | ms | mV ...
        :param min_value: smallest allowed value
        :param max_value: biggest allowed value
        :param fwrite: formula to eval between the value received and what
                       will be send.
        :param fread: formula to eval to the read from hardware value, the
                      result of which will be returned
        """
        self.__address = address
        self.__name = name
        assert_exceptions = []
        for element in Access:
            if access.lower() == element.name.lower():
                self.__access = Access(element.value)
                break
        else:
            assert_exceptions.append("access mode")
        for element in AttrType:
            if attr_type.lower() == element.name.lower():
                self.__attr_type = AttrType(element.value)
                break
        else:
            assert_exceptions.append("attribute type")
        for element in DataType:
            if data_type.lower() == element.name.lower():
                self.__data_type = DataType(element.value)
                break
        else:
            assert_exceptions.append("data type")
        self.__unit = unit
        self.__min_value = min_value
        self.__max_value = max_value
        self.__fwrite = fwrite
        self.__fread = fread
        if len(assert_exceptions) != 0:
            raise AssertionError(f"Incorrect parameters: {assert_exceptions}")

    def __str__(self):
        if self.address is not None:
            return f"0x{self.address:X}:{self.name}"
        else:
            return f"None:{self.name}"

    def __repr__(self):
        return f"{self.__str__()}({self.access}, {self.attr_type}, " \
               f"{self.data_type})"

    @property
    def address(self):
        return self.__address

    @property
    def name(self):
        return self.__name

    @property
    def access(self):
        return self.__access

    @property
    def attr_type(self):
        return self.__attr_type

    @property
    def data_type(self):
        return self.__data_type

    @property
    def unit(self):
        return self.__unit

    @property
    def min_value(self):
        return self.__min_value

    @property
    def max_value(self):
        return self.__max_value

    @property
    def fwrite(self):
        return self.__fwrite

    @property
    def fread(self):
        return self.__fread

    @property
    def value(self):
        return self.__value

    @property
    def last_update(self):
        return self.__last_update

    @property
    def last_update_float(self):
        if self.__last_update is None:
            return
        return float(self.__last_update.strftime('%s.%f'))

    def set_value(self, value, timestamp=None):
        if value != self.value and value is not None:
            if self.__data_type in [DataType.bool]:
                value = bool(value)
            elif self.__data_type in [DataType.short, DataType.long]:
                value = int(value)
            elif self.__data_type in [DataType.float, DataType.volts,
                                      DataType.angle]:
                value = float(value)
            elif self.__data_type in [DataType.string]:
                value = str(value)
            else:
                raise TypeError
            self.__value = value
            if timestamp is None:
                self.__last_update = datetime.now()
            else:
                self.__last_update = timestamp
